Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 7989)
@@ -32,6 +32,5 @@
   [StorableClass]
   [Item("SymbolicDataAnalysisExpressionTreeInterpreter", "Interpreter for symbolic expression trees including automatically defined functions.")]
-  public sealed class SymbolicDataAnalysisExpressionTreeInterpreter : ParameterizedNamedItem,
-    ISymbolicDataAnalysisExpressionTreeInterpreter, ISymbolicTimeSeriesPrognosisExpressionTreeInterpreter {
+  public class SymbolicDataAnalysisExpressionTreeInterpreter : ParameterizedNamedItem, ISymbolicDataAnalysisExpressionTreeInterpreter {
     private const string CheckExpressionsWithIntervalArithmeticParameterName = "CheckExpressionsWithIntervalArithmetic";
     private const string EvaluatedSolutionsParameterName = "EvaluatedSolutions";
@@ -67,6 +66,6 @@
 
     [StorableConstructor]
-    private SymbolicDataAnalysisExpressionTreeInterpreter(bool deserializing) : base(deserializing) { }
-    private SymbolicDataAnalysisExpressionTreeInterpreter(SymbolicDataAnalysisExpressionTreeInterpreter original, Cloner cloner) : base(original, cloner) { }
+    protected SymbolicDataAnalysisExpressionTreeInterpreter(bool deserializing) : base(deserializing) { }
+    protected SymbolicDataAnalysisExpressionTreeInterpreter(SymbolicDataAnalysisExpressionTreeInterpreter original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new SymbolicDataAnalysisExpressionTreeInterpreter(this, cloner);
@@ -79,4 +78,10 @@
     }
 
+    protected SymbolicDataAnalysisExpressionTreeInterpreter(string name, string description)
+      : base(name, description) {
+      Parameters.Add(new ValueParameter<BoolValue>(CheckExpressionsWithIntervalArithmeticParameterName, "Switch that determines if the interpreter checks the validity of expressions with interval arithmetic before evaluating the expression.", new BoolValue(false)));
+      Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName, "A counter for the total number of solutions the interpreter has evaluated", new IntValue(0)));
+    }
+
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
@@ -95,47 +100,27 @@
 
     public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset, IEnumerable<int> rows) {
-      return GetSymbolicExpressionTreeValues(tree, dataset, new string[] { "#NOTHING#" }, rows);
-    }
-
-    public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset, string[] targetVariables, IEnumerable<int> rows) {
-      return GetSymbolicExpressionTreeValues(tree, dataset, targetVariables, rows, 1);
-    }
-
-    // for each row for each horizon for each target variable one value 
-    public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset, string[] targetVariables, IEnumerable<int> rows, int horizon) {
       if (CheckExpressionsWithIntervalArithmetic.Value)
         throw new NotSupportedException("Interval arithmetic is not yet supported in the symbolic data analysis interpreter.");
 
       EvaluatedSolutions.Value++; // increment the evaluated solutions counter
-      var state = PrepareInterpreterState(tree, dataset, targetVariables[0]);
-
-      // produce a n-step forecast for each target variable for all rows
-      var cachedPrognosedValues = new Dictionary<string, double[]>();
-      //foreach (var targetVariable in targetVariables)
-      //  cachedPrognosedValues[targetVariable] = new double[horizon];
+      var state = PrepareInterpreterState(tree, dataset);
+
       foreach (var rowEnum in rows) {
         int row = rowEnum;
-        for (int localRow = row; localRow < row + horizon; localRow++) {
-          //int localRow = horizonRow; // create a local variable for the ref parameter
-          yield return Evaluate(dataset, ref localRow, row - 1, state, cachedPrognosedValues);
-          //cachedPrognosedValues[targetVariables[c]][horizonRow - row] = prog;
-          state.Reset();
-        }
+        yield return Evaluate(dataset, ref row, state);
+        state.Reset();
       }
     }
 
-    private InterpreterState PrepareInterpreterState(ISymbolicExpressionTree tree, Dataset dataset, string targetVariable) {
+    private InterpreterState PrepareInterpreterState(ISymbolicExpressionTree tree, Dataset dataset) {
       Instruction[] code = SymbolicExpressionTreeCompiler.Compile(tree, OpCodes.MapSymbolToOpCode);
       int necessaryArgStackSize = 0;
-      for (int i = 0; i < code.Length; i++) {
-        Instruction instr = code[i];
+      foreach (Instruction instr in code) {
         if (instr.opCode == OpCodes.Variable) {
           var variableTreeNode = (VariableTreeNode)instr.dynamicNode;
           instr.iArg0 = dataset.GetReadOnlyDoubleValues(variableTreeNode.VariableName);
-          code[i] = instr;
         } else if (instr.opCode == OpCodes.LagVariable) {
           var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
           instr.iArg0 = dataset.GetReadOnlyDoubleValues(laggedVariableTreeNode.VariableName);
-          code[i] = instr;
         } else if (instr.opCode == OpCodes.VariableCondition) {
           var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
@@ -148,18 +133,18 @@
     }
 
-    private double Evaluate(Dataset dataset, ref int row, int lastObservedRow, InterpreterState state, Dictionary<string, double[]> cachedPrognosedValues) {
+    protected virtual double Evaluate(Dataset dataset, ref int row, InterpreterState state) {
       Instruction currentInstr = state.NextInstruction();
       switch (currentInstr.opCode) {
         case OpCodes.Add: {
-            double s = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              s += Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double s = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              s += Evaluate(dataset, ref row, state);
             }
             return s;
           }
         case OpCodes.Sub: {
-            double s = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              s -= Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double s = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              s -= Evaluate(dataset, ref row, state);
             }
             if (currentInstr.nArguments == 1) s = -s;
@@ -167,14 +152,14 @@
           }
         case OpCodes.Mul: {
-            double p = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              p *= Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double p = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              p *= Evaluate(dataset, ref row, state);
             }
             return p;
           }
         case OpCodes.Div: {
-            double p = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              p /= Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double p = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              p /= Evaluate(dataset, ref row, state);
             }
             if (currentInstr.nArguments == 1) p = 1.0 / p;
@@ -182,48 +167,48 @@
           }
         case OpCodes.Average: {
-            double sum = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              sum += Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double sum = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              sum += Evaluate(dataset, ref row, state);
             }
             return sum / currentInstr.nArguments;
           }
         case OpCodes.Cos: {
-            return Math.Cos(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Cos(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Sin: {
-            return Math.Sin(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Sin(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Tan: {
-            return Math.Tan(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Tan(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Square: {
-            return Math.Pow(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues), 2);
+            return Math.Pow(Evaluate(dataset, ref row, state), 2);
           }
         case OpCodes.Power: {
-            double x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            double y = Math.Round(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            double x = Evaluate(dataset, ref row, state);
+            double y = Math.Round(Evaluate(dataset, ref row, state));
             return Math.Pow(x, y);
           }
         case OpCodes.SquareRoot: {
-            return Math.Sqrt(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Sqrt(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Root: {
-            double x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            double y = Math.Round(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            double x = Evaluate(dataset, ref row, state);
+            double y = Math.Round(Evaluate(dataset, ref row, state));
             return Math.Pow(x, 1 / y);
           }
         case OpCodes.Exp: {
-            return Math.Exp(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Exp(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Log: {
-            return Math.Log(Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues));
+            return Math.Log(Evaluate(dataset, ref row, state));
           }
         case OpCodes.Gamma: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.gammafunction(x);
           }
         case OpCodes.Psi: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else if (x.IsAlmost(0.0)) return double.NaN;
@@ -232,10 +217,10 @@
           }
         case OpCodes.Dawson: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             return alglib.dawsonintegral(x);
           }
         case OpCodes.ExponentialIntegralEi: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             return alglib.exponentialintegralei(x);
@@ -243,5 +228,5 @@
         case OpCodes.SineIntegral: {
             double si, ci;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -252,5 +237,5 @@
         case OpCodes.CosineIntegral: {
             double si, ci;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -261,5 +246,5 @@
         case OpCodes.HyperbolicSineIntegral: {
             double shi, chi;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -270,5 +255,5 @@
         case OpCodes.HyperbolicCosineIntegral: {
             double shi, chi;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -279,5 +264,5 @@
         case OpCodes.FresnelCosineIntegral: {
             double c = 0, s = 0;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -288,5 +273,5 @@
         case OpCodes.FresnelSineIntegral: {
             double c = 0, s = 0;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -297,5 +282,5 @@
         case OpCodes.AiryA: {
             double ai, aip, bi, bip;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -306,5 +291,5 @@
         case OpCodes.AiryB: {
             double ai, aip, bi, bip;
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else {
@@ -314,32 +299,32 @@
           }
         case OpCodes.Norm: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.normaldistribution(x);
           }
         case OpCodes.Erf: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.errorfunction(x);
           }
         case OpCodes.Bessel: {
-            var x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.besseli0(x);
           }
         case OpCodes.IfThenElse: {
-            double condition = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double condition = Evaluate(dataset, ref row, state);
             double result;
             if (condition > 0.0) {
-              result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues); state.SkipInstructions();
+              result = Evaluate(dataset, ref row, state); state.SkipInstructions();
             } else {
-              state.SkipInstructions(); result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+              state.SkipInstructions(); result = Evaluate(dataset, ref row, state);
             }
             return result;
           }
         case OpCodes.AND: {
-            double result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              if (result > 0.0) result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double result = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              if (result > 0.0) result = Evaluate(dataset, ref row, state);
               else {
                 state.SkipInstructions();
@@ -349,7 +334,7 @@
           }
         case OpCodes.OR: {
-            double result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              if (result <= 0.0) result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double result = Evaluate(dataset, ref row, state);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              if (result <= 0.0) result = Evaluate(dataset, ref row, state);
               else {
                 state.SkipInstructions();
@@ -359,15 +344,15 @@
           }
         case OpCodes.NOT: {
-            return Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues) > 0.0 ? -1.0 : 1.0;
+            return Evaluate(dataset, ref row, state) > 0.0 ? -1.0 : 1.0;
           }
         case OpCodes.GT: {
-            double x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            double y = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double x = Evaluate(dataset, ref row, state);
+            double y = Evaluate(dataset, ref row, state);
             if (x > y) return 1.0;
             else return -1.0;
           }
         case OpCodes.LT: {
-            double x = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            double y = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double x = Evaluate(dataset, ref row, state);
+            double y = Evaluate(dataset, ref row, state);
             if (x < y) return 1.0;
             else return -1.0;
@@ -376,5 +361,5 @@
             var timeLagTreeNode = (LaggedTreeNode)currentInstr.dynamicNode;
             row += timeLagTreeNode.Lag;
-            double result = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double result = Evaluate(dataset, ref row, state);
             row -= timeLagTreeNode.Lag;
             return result;
@@ -386,9 +371,9 @@
             for (int i = 0; i < Math.Abs(timeLagTreeNode.Lag); i++) {
               row += Math.Sign(timeLagTreeNode.Lag);
-              sum += Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+              sum += Evaluate(dataset, ref row, state);
               state.ProgramCounter = savedPc;
             }
             row -= timeLagTreeNode.Lag;
-            sum += Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            sum += Evaluate(dataset, ref row, state);
             return sum;
           }
@@ -400,11 +385,11 @@
         case OpCodes.Derivative: {
             int savedPc = state.ProgramCounter;
-            double f_0 = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues); row--;
+            double f_0 = Evaluate(dataset, ref row, state); row--;
             state.ProgramCounter = savedPc;
-            double f_1 = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues); row -= 2;
+            double f_1 = Evaluate(dataset, ref row, state); row -= 2;
             state.ProgramCounter = savedPc;
-            double f_3 = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues); row--;
+            double f_3 = Evaluate(dataset, ref row, state); row--;
             state.ProgramCounter = savedPc;
-            double f_4 = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double f_4 = Evaluate(dataset, ref row, state);
             row += 4;
 
@@ -415,5 +400,5 @@
             double[] argValues = new double[currentInstr.nArguments];
             for (int i = 0; i < currentInstr.nArguments; i++) {
-              argValues[i] = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+              argValues[i] = Evaluate(dataset, ref row, state);
             }
             // push on argument values on stack 
@@ -425,5 +410,5 @@
             state.ProgramCounter = (ushort)currentInstr.iArg0;
             // evaluate the function
-            double v = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double v = Evaluate(dataset, ref row, state);
 
             // delete the stack frame
@@ -440,14 +425,11 @@
             if (row < 0 || row >= dataset.Rows) return double.NaN;
             var variableTreeNode = (VariableTreeNode)currentInstr.dynamicNode;
-            if (row <= lastObservedRow || !cachedPrognosedValues.ContainsKey(variableTreeNode.VariableName)) return ((IList<double>)currentInstr.iArg0)[row] * variableTreeNode.Weight;
-            else return cachedPrognosedValues[variableTreeNode.VariableName][row - lastObservedRow - 1] * variableTreeNode.Weight;
+            return ((IList<double>)currentInstr.iArg0)[row] * variableTreeNode.Weight;
           }
         case OpCodes.LagVariable: {
             var laggedVariableTreeNode = (LaggedVariableTreeNode)currentInstr.dynamicNode;
             int actualRow = row + laggedVariableTreeNode.Lag;
-            if (actualRow < 0 || actualRow >= dataset.Rows)
-              return double.NaN;
-            if (actualRow <= lastObservedRow || !cachedPrognosedValues.ContainsKey(laggedVariableTreeNode.VariableName)) return ((IList<double>)currentInstr.iArg0)[actualRow] * laggedVariableTreeNode.Weight;
-            else return cachedPrognosedValues[laggedVariableTreeNode.VariableName][actualRow - lastObservedRow - 1] * laggedVariableTreeNode.Weight;
+            if (actualRow < 0 || actualRow >= dataset.Rows) return double.NaN;
+            return ((IList<double>)currentInstr.iArg0)[actualRow] * laggedVariableTreeNode.Weight;
           }
         case OpCodes.Constant: {
@@ -459,18 +441,13 @@
         //to determine the relative amounts of the true and false branch see http://en.wikipedia.org/wiki/Logistic_function
         case OpCodes.VariableCondition: {
-            if (row < 0 || row >= dataset.Rows)
-              return double.NaN;
+            if (row < 0 || row >= dataset.Rows) return double.NaN;
             var variableConditionTreeNode = (VariableConditionTreeNode)currentInstr.dynamicNode;
-            double variableValue;
-            if (row <= lastObservedRow || !cachedPrognosedValues.ContainsKey(variableConditionTreeNode.VariableName))
-              variableValue = ((IList<double>)currentInstr.iArg0)[row];
-            else
-              variableValue = cachedPrognosedValues[variableConditionTreeNode.VariableName][row - lastObservedRow - 1];
+            double variableValue = ((IList<double>)currentInstr.iArg0)[row];
 
             double x = variableValue - variableConditionTreeNode.Threshold;
             double p = 1 / (1 + Math.Exp(-variableConditionTreeNode.Slope * x));
 
-            double trueBranch = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
-            double falseBranch = Evaluate(dataset, ref row, lastObservedRow, state, cachedPrognosedValues);
+            double trueBranch = Evaluate(dataset, ref row, state);
+            double falseBranch = Evaluate(dataset, ref row, state);
 
             return trueBranch * p + falseBranch * (1 - p);
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7989)
@@ -312,7 +312,5 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="obj\" />
-  </ItemGroup>
+  <ItemGroup />
   <ItemGroup>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs	(revision 7989)
@@ -22,10 +22,9 @@
 using System.Windows.Forms;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.MainForm;
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   [View("TimeSeriesPrognosisnSolution View")]
-  [Content(typeof(TimeSeriesPrognosisSolutionBase), false)]
+  [Content(typeof(TimeSeriesPrognosisSolution), false)]
   public partial class TimeSeriesPrognosisSolutionView : DataAnalysisSolutionView {
     public TimeSeriesPrognosisSolutionView() {
@@ -33,6 +32,6 @@
     }
 
-    public new TimeSeriesPrognosisSolutionBase Content {
-      get { return (TimeSeriesPrognosisSolutionBase)base.Content; }
+    public new TimeSeriesPrognosisSolution Content {
+      get { return (TimeSeriesPrognosisSolution)base.Content; }
       set { base.Content = value; }
     }
